Type.registerNamespace('ApracJs.UI');

ApracJs.UI.PanelConfigAction = function() {
  ApracJs.UI.PanelConfigAction.initializeBase(this);
  this._changed = false;
  this.PanelContainer = null;
}

ApracJs.UI.PanelConfigAction.prototype = {
  initialize: function() {
    ApracJs.UI.PanelConfigAction.callBaseMethod(this, 'initialize');

    this._refresh();

    $common.addStep({
      tipsId: "_PanelConfig_Table",
      control: this.get_form().grid0
    }, "ұ໥϶ݣͬһ֧϶");
    $common.addStep({
      tipsId: "_PanelConfig_Row",
      control: this.get_form().grid0._rowsTable.firstChild.firstChild
    }, "˫пʵұݽ");
  },

  dispose: function() {
    ApracJs.UI.PanelConfigAction.callBaseMethod(this, 'dispose');
  },

  _refresh: function() {
    var frm = this.get_form();
    var panel = this.PanelContainer = frm.PanelContainer;
    var hasMore = panel.get_button().get_visible();
    frm.grid1.findColumn('chk').set_visible(hasMore);
    frm.grid1.resetColumnStretch();

    frm.grid0.refresh(this.getData(panel._getDesignControls(true)));
    frm.grid1.refresh(this.getData(panel._getPopupControls(true)));

    frm.grid0.set_allowMultiSelectedRow(false); // ֹѡ϶ô
    frm.grid1.set_allowMultiSelectedRow(false); // ֹѡ϶ô
    frm.grid1.set_dragField("text"); // ϶ʾ϶ı
    frm.grid0.set_dragField("text");
  },

  getData: function(controls) {
    var data = [];
    //var notIds = this.PanelContainer._notConfigIds || [];
    for (var i = 0; i < controls.length; i++) {
      var control = controls[i];
      if (!control.get_visible(true)) continue;
      //var id = control.get_idPart();
      //if (Array.contains(notIds, id)) continue; // õĲʾ

      var txt = "";
      if (control.get_label) txt = control.get_label();
      if (!txt && control.get_text) txt = control.get_text();
      if (!txt && control.get_dataField) txt = control.get_dataField();
      if (!txt && control.get_tag) txt = control.get_tag();
      if (!txt) txt = control.get_id();

      txt = $craba.trimLabel(txt);
      //var type = Object.getTypeName(control);
      //type = type.substr(type.lastIndexOf(".") + 1);

      var item = {
        id: control.get_id(),
        parid: control.get_idPart(),
        configID: control._panelConfigID,
        text: txt,
        chk: control._group ? true : false
      };
      data.push(item);
    }
    return data;
  },

  doCellRender: function(sender, args) {
    var rowIndex = args.get_rowIndex();
    var column = args.get_column();
    var dataField = column.get_dataField();
    if (dataField !== 'text') return;

    var data = sender.findRowData(rowIndex);
    if (!data) return;

    var notIds = this.PanelContainer._notConfigIds || [];
    if (Array.contains(notIds, data.parid)) {
      args.set_style('font-weight:bold;');
    }
  },

  canMove: function(rowIndex, grid) {
    var notIds = this.PanelContainer._notConfigIds || [];
    var data = grid.findRowData(rowIndex);
    if (!data) return false;
    if (Array.contains(notIds, data.parid)) {
      $common.showInfo('[' + data.text + ']ƶֻŶ');
      return false; // õֻ򣬲ܸıʾʽ
    }
    $common.hideHint();
    return true;
  },

  doDrop: function(sender, args) {
    $common.hideHint();
    var form = this.get_form();
    var grid0 = form.grid0;
    var gridS = args.get_source();
    var gridT = args.get_target();
    var dIndex = args.get_dragIndex();
    var sIndex = gridS.get_selectedRowIndex();
    var offsetIndex = 0;

    if (gridS == gridT) {
      if (dIndex == sIndex || dIndex == sIndex - 1) return; // ûиıλ
      if (dIndex < sIndex) offsetIndex = -1;
    } else {
      /*if (grid0 == gridS && grid0.get_recordCount() <= 2) {
        $common.showTips("Ӧչʾؼ");
        args.set_cancel(true);
        return;
      }*/
      if (!this.canMove(dIndex, gridS)) {
        $common.showHint('вƶֻ');
        args.set_cancel(true);
        return; // ػʾֻ
      }

      sIndex = gridT.get_selectedRowIndex();
      if (sIndex < 0) sIndex = 0;
    }

    var data = gridS.findRowData(dIndex);
    var data1 = gridT.findRowData(sIndex);

    gridS.deleteRow(dIndex, true);
    data.chk = false;
    if (gridT.get_recordCount() > 0) {
      gridT.insertRowData(sIndex + offsetIndex, data);
    } else {
      gridT.appendRowData(data);
    }

    this.saveChanges(data, data1);
  },

  saveChanges: function(data0, data1) {
    this._changed = true;
    this.PanelContainer._updatePanel(data0 ? data0.parid : null, data1 ? data1.parid : null);
  },

  doShowMore: function(sender) {
    var grid = sender;
    var form = sender.get_form();
    var grid1 = form.grid1;
    /*
    if (grid.get_recordCount() <= 2) {
      $common.showTips("Ӧչʾؼ");
      return;
    }*/

    var data = grid.get_selectedRowData();
    if (!data) return;
    if (!this.canMove(grid.get_selectedRowIndex(), grid)) return; // ػʾֻ

    data = Object.clone(data);
    data.chk = false;
    var rIndex = grid.get_selectedRowIndex();
    grid.deleteRow(rIndex);
    grid1.appendRowData(data);
    this.saveChanges(data, null);
  },

  doShowMain: function(sender) {
    var grid = sender;
    var form = sender.get_form();
    var grid0 = form.grid0;

    var data = grid.get_selectedRowData();
    if (!data) return;
    if (!this.canMove(grid.get_selectedRowIndex(), grid)) return; // ػʾֻ

    data = Object.clone(data);
    var rIndex = grid.get_selectedRowIndex();
    grid.deleteRow(rIndex);
    grid0.appendRowData(data);
    this.saveChanges(data, null);
  },

  doReset: function(sender) {
    Sys.UI.MessageBox.confirm("ȷҪԭĬ", Function.createDelegate(this, this._doReset));
  },

  _doReset: function(result) {
    if (!result) return;

    this._changed = false;
    var panel = this.PanelContainer;
    if (panel.get_configData()) {
      panel.set_configData(null);
      this._saveData(null);
    }
    panel.resetConfig();
    this._refresh();
  },

  doSave: function(sender) {
    this.get_form().doOk();
  },

  doClosed: function(frm, args) {
    if (!this._changed) {
      return;
    }

    var form = this.get_form();
    var list0 = form.grid0.get_dataController().save();
    var list1 = form.grid1.get_dataController().save();
    //$debug.traceDump(list0);

    var ids0 = this._getIds(list0);
    var ids1 = this._getIds(list1, true);
    var configData = {};
    configData.design = ids0.join(",");
    configData.popup = ids1.join(",");
    this.PanelContainer._saveConfigData(configData);

    // webmethod
    //$debug.traceDump(configData);
    this._saveData(configData);
  },

  doGroupChange: function(sender, args) {
    this._changed = true;

    var rowIndex = args.get_rowIndex();
    var data = this.get_form().grid1.getRowData(rowIndex);
    var panel = this.PanelContainer;
    panel._updatePopup(data.parid, args.get_value());
  },

  _saveData: function(configData) {
    var panel = this.PanelContainer;
    var panelId = panel.get_guid() + "_" + panel.get_configID();

    if ($craba.checkConfig('panel', panelId, configData)) return;
    panel.saveConfig(panelId, configData);
  },

  _getIds: function(list, allowGroup) {
    var ids = [];
    for (var i = 0, count = list.length; i < count; i++) {
      var item = list[i];
      if (item.configID) {
        ids.push(item.configID)
      } else {
        ids.push(item.parid);
      }
      if (item.chk && allowGroup) {
        ids.push(""); // 
      }
    }
    return ids
  }
}
ApracJs.UI.PanelConfigAction.registerClass('ApracJs.UI.PanelConfigAction', Sys.UI.PageAction);