var fs = require('fs');
var path = require('path');
var delegate = require('../../lib/common/utils.js').createDelegate;
var config = require('../../lib/config.js').apracConfig;

class Tools {
  context() {
    var data = {};
    data["updateTimeApracjs"] = config.updateTime || this.mtime(path.join(path.resolve(__dirname, '../../'), 'package.json'));
    data["updateTimeProduct"] = config.productUpdateTime || this.mtime(path.join(process.cwd(), 'package.json'));
    data["updateTimeGlobal"] = this.mtime(path.join(process.cwd(), 'global.js'));
    data["updateTimeConfig"] = this.mtime(path.join(process.cwd(), 'config.js'));

    data["versionApracjs"] = config.version;
    data["versionProduct"] = config.productVersion;
    data["env"] = config.env;

    var fileList = [];
    this.buildFiles(config.webFolder, fileList, 0);

    data['files'] = fileList.sort(function (item0, item1) {
      return item0.isFile;
    });
    return data;
  }

  mtime(filePath) {
    if (!fs.existsSync(filePath)) {
      return 'no file';
    }

    var stat = fs.statSync(filePath);
    var lastModified = stat.mtime;
    return lastModified;
  }


  buildFiles(folderPath, fileList, pid, pData) {
    var that = this;
    var index = 0;
    var files = fs.readdirSync(folderPath);
    files.forEach(function (fileName) {
      var filePath = path.join(folderPath, fileName);
      var stats = fs.statSync(filePath);
      if (stats.isFile()) {
        var ext = path.extname(filePath).toLowerCase();
        if (ext != ".jsx" && ext != '.css') return;

        if (pData) {
          fileList.push(pData); // ӼĿ¼
          pData = null;
        }

        var data = {};
        data.name = "File" + index + ext; // fileName; // ʵļ
        data.id = pid + "_" + (++index);
        data.pid = pid;
        data.time = stats.mtime;
        data.isFile = true;
        fileList.push(data);

      } else if (stats.isDirectory()) {
        var data = {};
        data.name = 'Folder' + index; // fileName; // ʵĿ¼
        data.pid = pid;
        data.id = pid + '_' + (++index);
        data.isFile = false;

        that.buildFiles(filePath, fileList, data.id, data);
      }
    });
  }
}
exports = module.exports = Tools;