﻿/*!
 * apracjs
 * Copyright(c) 2017 by wssf
 * 2017-04-26
 * 外部调用apracjs的唯一入口
 */
'use strict'
var path = require('path');

/*检查版本号*/
var version = require('./lib/common/version.js');
version.checkVersion();

/* 全局重写nodejs日期类型 */
require('./lib/common/prototype.js');

/* 初始化全局配置(必须放最前面) */
var config = require('./lib/config.js');

/* 对产品输出公共类、方法、重写 */
exports = module.exports = require('./lib/aprac.js');

/*需要优先其他模块注册*/
exports.Log = require('./lib/log/log4Helper.js').getInstance();
exports.Config = config;
exports.ApracConfig = config.apracConfig;

exports.Cache = require('./lib/common/cache.js');
exports.CacheManager = require('./lib/common/cacheManager.js');
exports.Enum = require('./lib/common/enum.js');
exports.LoginPage = require('./lib/scripts/loginPageInfo.js');
exports.MenuNode = require('./lib/scripts/menuNode.js');
exports.SqlPagerDataSource = require('./lib/scripts/dataSource/sqlPagerDataSource.js');
exports.DbPagerDataSource = require('./lib/scripts/dataSource/dbPagerDataSource.js');
exports.TreeDataSource = require('./lib/scripts/dataSource/treeDataSource.js');
exports.SqlTreeGridDataSource = require('./lib/scripts/dataSource/sqlTreeGridDataSource.js');
exports.FileUpload = require('./lib/scripts/fileUpload.js');
exports.ExcelTemplate = require('./lib/scripts/excelexport.js');
exports.DbHelper = require('./lib/database/dbHelper.js');
exports.SqlHelper = require('./lib/database/sqlHelper.js');
exports.Utils = require('./lib/common/utils.js');
exports.StringUtils = require('./lib/common/stringUtils.js');
exports.StringBuilder = require('./lib/common/stringBuilder.js');
exports.Cuid = require('./lib/common/cuid.js');
exports.ConfigStore = require('./lib/scripts/configStore.js');
exports.ClientUserStore = require('./lib/scripts/clientUserStore.js');
exports.Bindings = require('./modules/bindings/bindings.js');
exports.IPrinter = require('./lib/scripts/iPrinter.js');
exports.Extend = require('./lib/apracExtend.js');

/* 程序启动全局执行一次global */
var global = require(path.join(process.cwd(), "global.js"));
new global();