﻿/* 重写js全局对象内置函数 */

'use strict'

//////////////////////日期相关函数/////////////////////////
Date.prototype.toString = function () {
  return this.format('yyyy-MM-dd hh:mm:ss');
}
Date.prototype.format = function(str) { 
    var Week = ['日', '一', '二', '三', '四', '五', '六'];

    str = str.replace(/yyyy|YYYY/, this.getFullYear());
    str = str.replace(/yy|YY/, (this.getYear() % 100) > 9 ? (this.getYear() % 100).toString() : '0' + (this.getYear() % 100));

    var month = this.getMonth() + 1;
    str = str.replace(/MM/, month > 9 ? month.toString() : '0' + month);
    str = str.replace(/M/g, month);

    str = str.replace(/w|W/g, Week[this.getDay()]);

    str = str.replace(/dd|DD/, this.getDate() > 9 ? this.getDate().toString() : '0' + this.getDate());
    str = str.replace(/d|D/g, this.getDate());

    str = str.replace(/hh|HH/, this.getHours() > 9 ? this.getHours().toString() : '0' + this.getHours());
    str = str.replace(/h|H/g, this.getHours());

    str = str.replace(/mm/, this.getMinutes() > 9 ? this.getMinutes().toString() : '0' + this.getMinutes());
    str = str.replace(/m/g, this.getMinutes());

    str = str.replace(/ss|SS/, this.getSeconds() > 9 ? this.getSeconds().toString() : '0' + this.getSeconds());
    str = str.replace(/s|S/g, this.getSeconds());

    str = str.replace(/fff|FFF/, this.getMilliseconds() > 99 ? this.getMilliseconds().toString() : '00' + this.getMilliseconds());
    str = str.replace(/ff|FF/, this.getMilliseconds() > 9 ? this.getMilliseconds().toString() : '0' + this.getMilliseconds());
    str = str.replace(/f|F/g, this.getMilliseconds());

    return str;
}
Date.prototype.toJSON = function () {
  return this.format('yyyy-MM-dd hh:mm:ss');
}


////////////字符串相关函数///////////////////
String.prototype.trim = function String$trim(c) {
  if (c == null || c == "") {
    return this.replace(/(^\s*)|(\s*$)/g, "");
  }
  var rg = new RegExp("^" + c + "*");
  var str = this.replace(rg, '');
  rg = new RegExp(c);
  var i = str.length;
  while (rg.test(str.charAt(--i)));
  return str.slice(0, i + 1);
}
String.prototype.trimStart = function String$trimStart(c) {
  if (c == null || c == "") {
    return this.replace(/^\s+/, "");
  }
  var rg = new RegExp("^" + c + "*");
  var str = this.replace(rg, '');
  return str;
}
String.prototype.trimEnd = function String$trimEnd(c) {
  if (c == null || c == "") {
    return this.replace(/\s+$/, '');
  }
  var str = this;
  var rg = new RegExp(c);
  var i = str.length;
  while (rg.test(str.charAt(--i)));
  return str.slice(0, i + 1);
}
String.prototype.padLeft = function String$padLeft(len, charStr) {
  var s = this + '';
  len = len - s.length + 1;
  if (len < 0) return s;
  return new Array(len).join(charStr, '') + s;
}
String.prototype.padRight = function String$padRight(len, charStr) {
  var s = this + '';
  len = len - s.length + 1;
  if (len < 0) return s;
  return s + new Array(len).join(charStr, '');
}
String.prototype.startsWith = function String$startsWith(prefix) {
  return (this.substr(0, prefix.length) === prefix);
}
String.prototype.endsWith = function String$endsWith(suffix) {
  return (this.substr(this.length - suffix.length) === suffix);
}