﻿/*!
 * apracjs
 * Copyright(c) 2017 by wssf
 * 2017-04-26
 */

'use strick'
var utils = require('./utils.js');

class StringBuilder {
  constructor(initialText) {
    this._parts = (typeof (initialText) !== 'undefined' && initialText !== null && initialText !== '') ?
      [initialText.toString()] : [];
    this._value = {};
    this._len = 0;
  }

  append(text) {
    this._parts[this._parts.length] = text;
    return this;
  }

  appendFormat() {
    var text = utils.format.apply(this, arguments);
    this._parts[this._parts.length] = text;
    return this;
  }

  appendLine(text) {
    this._parts[this._parts.length] =
      ((typeof (text) === 'undefined') || (text === null) || (text === '')) ?
        '\r\n' : text + '\r\n';
    return this;
  }

  length() {
    return this.toString(null).length;
  }

  clear() {
    this._parts = [];
    this._value = {};
    this._len = 0;
    return this;
  }

  isEmpty() {
    return this._parts.length === 0;
  }

  toString(separator) {
    separator = separator || '';
    var parts = this._parts;
    if (this._len !== parts.length) {
      this._value = {};
      this._len = parts.length;
    }
    var val = this._value;
    if (typeof (val[separator]) === 'undefined') {
      if (separator !== '') {
        for (var i = 0; i < parts.length;) {
          if ((typeof (parts[i]) === 'undefined') || (parts[i] === '') || (parts[i] === null)) {
            parts.splice(i, 1);
          } else {
            i++;
          }
        }
      }
      val[separator] = this._parts.join(separator);
    }
    return val[separator];
  }
}

module.exports = StringBuilder;