'use strict'

var path = require('path');
var fs = require('fs');
var baseDistributor = require('./lib/baseDistributor.js')
var apracConfig = require('../config.js').apracConfig
var utils = require('../common/utils')

class CoreDistributor{
    constructor(config){
        var parentDir = path.join(process.cwd(), apracConfig.appFolder);
        if(!fs.existsSync(parentDir)){
            fs.mkdirSync(parentDir);
        }
        //初始化分发器
        var dir = path.join(process.cwd(), apracConfig.appFolder, config.webFolder);
        var exist = fs.existsSync(dir);
        if(exist){
            //fs.rmdirSync(dir);//删除之前的缓存
        }
        //fs.mkdirSync(dir);
        //通过配置，在启动的时候删除对应APP的目录，确保能下载到最新目录
        var _baseDistributor = baseDistributor.Init({
            url:config.url,
            method:config.method,
            appName:config.appName
        });
        utils.createDelegateForAllFun(_baseDistributor, this)
    }
}
module.exports = CoreDistributor;