//http分发器
'use strict'

var http = require('http')
var url = require('url')

class BaseDistributor {
    constructor(config) {
        this._appName = config.appName;
        this._url = config.url;
    }

    static Init(config) {
        var method = config.method ? config.method.toString().toLowerCase() : "";
        switch (method) {
            case "http":
                return new HttpDistributor(config);
            default:
                throw Exception("当前还不支持" + method + "方式");
        }
    }

    getAppName() {
        return this._appName;
    }
    get(req, data, ext) {
        return {
            redirectUrl: "",
            context: {},
            url: ""
        }
    }
    down(req, url) {

    }

    NetRequest(options, done) {
    }
}

class HttpDistributor extends BaseDistributor {
    constructor(config) {
        super(config);
    }
    NetRequest(res, options, data, done) {
        var rtData = '';

        var httpReq = http.request(options, (res) => {
            res.on('data', function (chunk) {
                rtData += chunk;
            });
            res.on('end', function () {
                var ndata = rtData && rtData.length > 0 ? JSON.parse(rtData) : rtData;
                done(ndata);
            });
        });
        httpReq.on("error", (e) => {
            console.log(`options=${options}  error=${e.message}`);
        })
        if (options.method == "post") {
            httpReq.write(data);
        }
        httpReq.end();
    }
    get(req, data, ext, done) {
        var rtData = '';
        var _url = url.parse(this._url);
        var options = {
            hostname: _url.hostname,
            port: _url.port,
            path: _url.pathname,
            method: "post",
            headers: {
                'Content-Type': 'application/json',// 不写这个参数，后台会接收不到数据
            }
        }
        switch (ext) {
            case "gspx":
                options.method = "get";
                this.NetRequest(req.res, options, {}, done);
                // rtData = {
                //     redirectUrl: "",
                //     context: {
                //         types: [1, 2],
                //         dropDownList: [{
                //             id: 123,
                //             name: "ABC"
                //         }, {
                //             id: 456,
                //             name: "DEF"
                //         }]
                //     },
                //     url: "http://localhost:1002/Edits.xml",//下载地址
                //     hasWebService: true
                // }
                break;
            case "ajax/js":

                options.method = "get";
                options.path = options.path + "/EditsEx";
                this.NetRequest(req.res, options, {}, done);
                // rtData = {
                //     mtime: new Date(),//最后修改时间
                //     serviceData: {
                //         namespace: "EditsEx",//指定访问命名空间
                //         namepath: "EditsEx",//命名路径
                //         methods: [{
                //             name: "GetGridData",
                //             args: []
                //         }]
                //     }
                // }
                break;
            case "ajax":
                //数据获取
                let postData = {
                    controller: 'EditsEx',
                    methodName: data.methodName
                };
                postData = JSON.stringify(postData);
                options.headers["Content-Length"] = postData.length;
                this.NetRequest(req.res, options, postData, done);
                //文件上传
                // if (data.methodName == "GetGridData") {
                //     rtData = [{
                //         test1: 'test1001',
                //         test2: 'test2002'
                //     },
                //     {
                //         test1: 'test1003',
                //         test2: 'test2004'
                //     }]
                // }
            default:
                break;
        }
        return rtData;
    }

    async down(req, url) {
        http.get(url)
    }
}
module.exports = BaseDistributor;