﻿/*!
 * apracjs
 * Copyright(c) 2017 by wssf
 * 2017-04-26
 * 处理R.axd资源请求，主要是为了统一资源的版本管理而设计
 */
'use strict'

var Handler = require('./handler.js');
var path = require('path');

class ResourceHandler extends Handler {
    constructor(app, distributor) {
        super(app, '.axd', distributor);
    }

    processRequest(req, res, done) {
        var staticHandler = this.Router.getHandler(req, this._app.get("staticTag"));
        var query = req.parsed.query;
        if (!query.r) { // R.axd?v=1446786173&r=/Login.js&tag=229
            done();
            return;
        }
        req.parsed.pathname = query.r; // 转换一下
        req.parsed.extname = path.extname(query.r).toLowerCase();
        staticHandler.processRequest(req, res, done);
    }
}

module.exports = ResourceHandler;