﻿/*!
 * ConfigStore配置存储器
 * Copyright(c) 2017 by wssf
 * 2017-06-29
 */

'use strict'
var urlParse = require('url').parse;
var debug = require('debug')('aprac:clientUserStore');
var config = require('../config.js');
var apracConfig = config.apracConfig;
var log = require('../log/log4Helper.js').getInstance();
var utils = require('../common/utils.js');

// 私有，平台默认配置管理器
class ClientStoreProvicer {
  constructor() {
    this.options = {
      loginUserIdKey: "LoginUserId",
      profileIdKey: "ProfileId"
    }
  }
  init(options) {
    this.inited = true; // 标记已经初始化
    log.writeInfo('ClientStoreProvicer init.', debug);
    utils.copyTo(options, this.options);
  }
}
var storeProvider = new ClientStoreProvicer();

exports.init = function(options) {
  storeProvider.init(options);
}

exports.getStore = function() {
  if (!storeProvider.inited) return null;

  return storeProvider;
}

