var utils = require('../../common/utils.js');
var config = require('../../config.js').apracConfig;

class DbTreeDataSource{
    constructor(data, parentIdFieldName, rootId){
        this._data = this._getAllParentIdRows(data, parentIdFieldName);
        this._rootId = rootId;
    }
    
    _getAllParentIdRows(data, parentIdFieldName){
        var dataArray = {};
        data.forEach(element => {
            var row = element;
            var pId = row[parentIdFieldName];
            var list = dataArray[pId];
            if(!list){
                list = [];
                dataArray[pId] = list;
            }
            list.push(row);
        });
        return dataArray;
    }
    
    getNode(textFieldName, idFieldName){
        var rootTree = {
            ChildNodes : []
        };
        var nodes = this._data[this._rootId];
        if(!nodes){
            return rootTree;//没有找到需要的
        }
        return this.InitChildNode(rootTree, textFieldName, idFieldName, this._rootId);
    }

    InitChildNode(parentNode, textFieldName, idFieldName, pid){
        var nodes = this._data[pid];
        delete this._data[pid];
        for(var i in nodes){
            var node = nodes[i];
            var treeNode = {
                Data:node,
                Text:node[textFieldName],
                ChildNodes:[]
            }
            this.InitChildNode(treeNode, textFieldName, idFieldName, node[idFieldName])
            parentNode.ChildNodes.push(treeNode);
        }
        return parentNode;
    }
}

module.exports = DbPagerDataSource;

module.exports = (data, textFieldName, idFieldName, parentIdFieldName, rootId) => {
    var tree = new DbTreeDataSource(data,parentIdFieldName, rootId);
    return tree.getNode(textFieldName, idFieldName);
};