﻿/*!
 * PagerDataSource
 * Copyright(c) 2017 by wssf
 * 2017-06-09
 */

'use strict'
var debug = require('debug')('aprac:PagerDataSource');
var utils = require('../../common/utils.js');
var config = require('../../config.js').apracConfig;

class PagerDataSource {
  constructor() {
    this._showAll = false;
    this._serverBinding = false;
  }

  getItemCount() {
    return 0;
  }

  getItemList(first, count) {
    return null;
  }

  invalidateCache() {}

  setQueryParams(queryParams) {
    this.queryParams = queryParams;
  }

  addSummaryItems(items) {
    // 子类处理
  }

  setOrders(orders) {
    this.orders = orders;
  }

  setFilter(filter) {
    this.filter = filter;
  }

  getOrderClause(defaultOrder) {
    var answer = this._getOrderClause(this.orders, null);
    return answer ? answer : defaultOrder || '';
  }

  _getOrderClause(orders, orderMap) {
    if (orders == null || orders.length == 0) {
      return "";
    }

    var answer = " order by ";
    for (var i = 0, count = orders.length; i < count; i++) {
      if (i > 0) {
        answer += ",";
      }
      var order = orders[i];
      var dataField = order.dataField;
      answer += utils.filterChar(dataField);
      if (!order.ascending) {
        answer += " desc";
      }
    }
    return answer;
  }
}

module.exports = PagerDataSource;