﻿/*!
 * PagerDataSource
 * Copyright(c) 2017 by wssf
 * 2018-08-12
 */

'use strict'
var SqlPagerDataSource = require('./sqlPagerDataSource.js');
var debug = require('debug')('aprac:SqlTreeGridDataSource');
var utils = require('../../common/utils.js');
var DbHelper = require('../../database/dbHelper.js');
var config = require('../../config.js').apracConfig;
var StringBuilder = require('../../common/stringBuilder.js');
var stringUtils = require('../../common/stringUtils.js');

class SqlTreeGridDataSource extends SqlPagerDataSource {
  constructor(connectionString, id, pid, rootValue) {
    super();
    this._idKey = id;
    this._pidKey = pid;
    this._rootValue = rootValue;
    this.connectionString = connectionString;
  }

  async afterSelect(db, pagerParams, sourceList) {
    var list = utils.clone(sourceList);
    await this.bindChildData(db, pagerParams, list, sourceList);
  }

  async bindChildData(db, pagerParams, list, sourceList) {
    for (var i = 0, count = list.length; i < count; i++) {
      var item = list[i];
      var childList = await this.doPrepareChild(db, pagerParams, item);
      if (!childList || childList.length == 0) continue;

      childList.forEach(item => { sourceList.push(item); });
      await this.bindChildData(db, pagerParams, childList, sourceList);                         // 递归子级的
    };
  }

  doPrepareChild(db, pagerParams, item) {
    return null;
  }
}

module.exports = SqlTreeGridDataSource;