﻿/*!
 * 打印相关接口
 * Copyright(c) 2018 by wssf
 * 2018-10-25
 */

'use strict'
var debug = require('debug')('aprac:iprinter');
var config = require('../config.js');
var apracConfig = config.apracConfig;
var log = require('../log/log4Helper.js').getInstance();
var utils = require('../common/utils.js');
var signature = require('cookie-signature');

exports.registerCloud = function(ICloudPrinterHandler) {
  this.cloudPrinterHandler = ICloudPrinterHandler;
}

exports.registerConfig = function(IReportConfig) {
  this.reportConfig = IReportConfig;
}

exports.getInitData = function(session) {
  var answer = {};
  var reportInit = this.IReportInit;
  if (reportInit) {
    answer.masterFields = {};
    reportInit.addMasterFields(answer.masterFields);
  }
  answer.cookie = apracConfig.sessionIdKey + "=" + encodeURIComponent('s:' + signature.sign(session.id, apracConfig.cookieSecret));
  return answer;
}