﻿/*!
 * httpContext
 * Copyright(c) 2017 by wssf
 * 2017-05-02
 */

'use strict'

let corstokenLogin = async function(req, TokenAuthFun, hasLogin){
    if(!TokenAuthFun){
        return;
    }
    if(typeof(TokenAuthFun) != "function"){
        throw new Error("注册的token授权不是函数");
    }
    await TokenAuthFun(req, hasLogin);
}

//TokenAuthFun:跨域token认证
exports.register = function(loginPageUrl, sessionVarName, TokenAuthFun) {
    this.loginPageUrl = loginPageUrl;
    this.sessionVarName = sessionVarName;
    this.isRegistered = true;
    this.TokenAuthFun = TokenAuthFun;
}

exports.checkHasLogin = async function(req, needLogin) {
    var session = req.session;
    if (needLogin) {
        if (session == null) {
            throw new Error("找不到 req.session");
        }
        if (!this.isRegistered) {
            throw new Error("使用[NeedLogin]要求通过Global.js调用Page.RegisterLoginPage");
        }
        var hasLogin = this.getHasLogin(session);
        //每一步都要判断，避免切换用户时，系统没有收到注销通知，导致其他用户登录后任然采用之前的信息
        if(this.TokenAuthFun){//这里加入注入方法，用于产品判断token
            await corstokenLogin(req, this.TokenAuthFun, hasLogin);
            hasLogin = this.getHasLogin(req.session);
        }
        return hasLogin;
    }
    return true;
}

exports.userInfo = function (req) {
    var session = req.session;
    if (!session) return {};
    var user = session[this.sessionVarName];
    return user == undefined ? {} : user;
}

exports.getHasLogin = function(session) {
    return session != null && session[this.sessionVarName] != null;
}
