'use strict'

class MenuNode {
  constructor() {
    this.childs = [];

    this.Text = arguments[0] ? arguments[0] : '';
    this.Icon = arguments[1] ? arguments[1] : '';
    this.Param = arguments[2] ? arguments[2] : '';
    this.OnClick = arguments[3] ? arguments[3] : '';
  }

  addChild(node) {
    this.childs.push(node);
  }

  toJson() {
    var nodeData = {
      ID: this.ID,
      Text: this.Text,
      Icon: this.Icon,
      Param: this.Param,
      OnClick: this.OnClick,
      ShowPage: this.ShowPage ? this.ShowPage : '',
      CssClass: this.CssClass ? this.CssClass : '',
      NavigateUrl: this.NavigateUrl ? this.NavigateUrl : '',
      BeginGroup: this.BeginGroup ? true : false,
      Shortcut: this.Shortcut ? this.Shortcut : '',
      Enabled: this.Enabled === false ? false : true,
      Visible: this.Visible === false ? false : true,
      ChildNodes: []
    }
    for (var i = 0, count = this.childs.length; i < count; i++) {
      var child = this.childs[i];
      nodeData.ChildNodes.push(child.toJson());
    }
    return nodeData;
  }
}
exports = module.exports = MenuNode;